library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
entity onehz is
	Generic ( osc_freq: natural := 50000000);
	port(
		nRESET: in std_logic; 			-- Button Pin 144
		clk: in std_logic; 				--50Mhz Clock Pin 17
		LED0: out std_logic := '1'; 	-- PIN 3
		LED1: out std_logic := '1'; 	-- PIN 7
		LED2: out std_logic := '1'		-- PIN 9
	);
end onehz;

architecture rtl of onehz is
	signal hz_25m: std_logic :='0';
   signal hz_1: std_logic :='0';
	signal hz_1sync: std_logic :='0';	
	signal led0_data: std_logic := '1';
	signal led1_data: std_logic := '1';
	signal led2_data: std_logic := '1';	
	begin

---------------------- Begin 50Mhz to 10Hz Clock divide ---------------------------

-- 50Mhz to 25Mhz predivide
   CLOCK_DIV2: process(clk,		nRESET)
   begin
   if nRESET = '0' then
      hz_25m <= '0';
   elsif rising_edge(clk) then
      hz_25m <= not hz_25m;
   end if;
   end process CLOCK_DIV2;	
	
-- 10HZ Clock	Process
   CLOCK_1HZ: process(hz_25m,		nRESET)
   VARIABLE ticks:integer range 0 to ((osc_freq/1)/2)-1;
   begin
   if nRESET = '0' then
      ticks:=0;
   elsif rising_edge(hz_25m) then
      ticks:=ticks+1;
      if ticks >=(((osc_freq/1)/2)/2)-1 then
         hz_1 <= not hz_1;
         ticks:=0;
      end if;
   end if;
   end process CLOCK_1HZ;

-- 10Hz resync to 50Mhz
   hz_1_sync: process(clk,hz_1,nRESET)
   begin
   if nRESET = '0' then
      hz_1sync <= '0';
   elsif rising_edge(clk) then
      hz_1sync <= hz_1;
   end if;
   end process hz_1_sync;	
	
---------------------- End 50Mhz to 10Hz Clock divide ---------------------------

	--First Process
	DATA_REGISTER_0: process(nRESET,hz_1sync)
	begin
		if nRESET = '0' then
		LED0_data <= '0';
		--LED1_data <= '0';
		--LED2_data <= '0';
		--LED0 <= LED0_data;
		elsif rising_edge(hz_1sync) then
		LED0_data <=  not LED0_data;
		--LED1_data <=  LED1_data;
		--LED2_data <=  LED2_data;
		
		end if;
	end process DATA_REGISTER_0;

		LED0 <=  LED0_data;
		--LED1 <=  LED1_data;
		--LED2 <=  LED2_data;
		
	--LED_BTN <= data;

end rtl;